//
//  MMSEXIFReader.h
//  MMSEmbeddedMetaData
//
//  Created by John Fox on 10/22/04.
//  Copyright 2004 MemoryMiner Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface MMSEXIFReader : NSObject {

}

+ (id)sharedReader;

- (NSDictionary *)metadataDataDictForFileAtPath:(NSString *)aPath;
- (NSDictionary *)iptcDataDictForFileAtPath:(NSString *)aPath;
- (NSDictionary *)gpsDataDictForFileAtPath:(NSString *)aPath;
- (NSDictionary *)exifDataDictForFileAtPath:(NSString *)aPath;
- (NSCalendarDate *)creationDateForFileAtPath:(NSString *)aPath;

@end
