// NSData_MMSCategories.h
//
// Author: john
// Date: Thu 12-Nov-1998
// CVS Info: $Id: NSData_MMSCategories.m,v 1.4 2002/12/12 02:27:45 kcremin Exp $ 
//
// Copyright (c) 2006 GroupSmarts, LLC. All rights reserved.

#import <Foundation/Foundation.h>

#include <zlib.h>

@interface NSData (MMSCategories)

+ (void *)autoreleasedMalloc:(size_t)lSize;
+ (void *)resizeAutoreleasedMalloc:(size_t)lSize forData:(void*)pData;
+ (id)dataWithBase64EncodedString:(NSString *)string;
- (NSString *)base64EncodedDataString;


- (NSData *)gzipDeflate;
- (NSData *)gzipInflate;


@end
