var nav = new NavBar();
var currentPictureLink;
var currentPersonLink;
var isShowingAll = true;
var currentPhotoIndex;
var locationMapMarkerHash = new Hash();
var bReuseMediaWindow = false
var mediaWindow
var screenW = 800, screenH = 600
var mySelectable;
var map;
var miniMap;
var miniMapIsVsible = false;
var slideShowIsPaused = false;
var activeSlideShow;
var INTERACTIVE_IMAGE_HEIGHT = 385;
var localizationHash = new Hash();
var requestedPhotoID;
var currentMapMarker;

// Photo Info Accordian state
var miniMapWindow;
var miniMapMarker;
var photoInfoAccordion;

// For hiding markers
var photoMarkerTimer;

if (parseInt(navigator.appVersion)>3)
{
    screenW = screen.width;
    screenH = screen.height;
} 

function initialize()
{
    //loadScript('http://api.maps.yahoo.com/v3.0/fl/javascript/apiloader.js?appid=memoryminer');
    //loadScript('http://api.maps.yahoo.com/ajaxymap?v=3.8&appid=oqemIDLV34E787LGs.kD3AszjhvqaswI_keXlewrWJLWnA2lC9pEwfmUp71aVBXX');
    //loadScript('scripts/moo.fx.js');
    //loadScript('scripts/moo.fx.pack.js');
    //loadScript('scripts/timed.slideshow.js');
    //loadScript('scripts/scriptaculous.js');
    //loadScript('scripts/selectable.js');
    //Element.hide('slideShowController');
    loadLocalizationInfo('./MMLocalizationTable.xml');
    
    var searchString = document.location.search;
    var feedURL = "index.rss";
    
    log('here in initialize document.location is ' +document.location +' pathname is ' +document.location.pathname + ' its search is ' +document.location.search);
    
    if (searchString.length > 0)
    {            
        requestedPhotoID = searchString.split('showPhoto=')[1];
        
        log('we have a search parameter in the URL requestedPhotoID is ' +requestedPhotoID);
    }
        
    //loadXMLDataFromURL('MediaObjectsData.xml');
    loadDataFromFeedURL(feedURL);
    
    MM_preloadImages('images/back_rollover.gif','images/stop_rollover.gif','images/pause_rollover.gif','images/play_rollover.gif', 'images/forward_rollover.gif');
    
}

function loadLocalizationInfo(aURL)
{
    var myRequest = createHTTPRequest();

    myRequest.onreadystatechange = function () {handleXMLocalizationLoad(myRequest);}

    myRequest.open("GET", aURL, true);

    myRequest.send("");
};

function handleXMLocalizationLoad(aRequest)
{
    var myDOMTree;
    var localeKey = getBrowserLanguage();
    
    // only if aRequest shows "loaded"
    if (aRequest.readyState == 4) 
    {
        myDOMTree = createDOMTreeFromRequest(aRequest);
                
        var myRoot = myDOMTree.getElementsByTagName("MMLocalizationInfo")[0];
        var myLocaleNode = myRoot.getElementsByTagName(localeKey)[0];

        if (myLocaleNode == null)
        {
            myLocaleNode = myRoot.getElementsByTagName('en')[0];
        }
        
        var myEntry;
                    
        for (var i = 0; i < myLocaleNode.childNodes.length; i++)
        {
            myEntry = myLocaleNode.childNodes[i];
            
            if (myEntry.nodeType == 1)
            {					                
                localizationHash.set(myEntry.nodeName, myEntry.firstChild.nodeValue);
            }
        }
        
        localizeUIElements();
    }
};

function localizeUIElements()
{
	document.title = (localizationHash.get('docTitle') + ': ' +storyName);
    $('interactiveNav').innerHTML = localizationHash.get('interactiveViewLinkLabel');
    //$('mapNav').innerHTML = localizationHash.get('mapViewLinkLabel');
    $('viewerNav').innerHTML = localizationHash.get('slideShowViewLinkLabel');
    $('loadingLabel').innerHTML = localizationHash.get('loadingLabel');
}

function loadScript(url)
{
    var e = document.createElement("script");
    e.type="text/javascript";
    e.src = url;
    document.getElementsByTagName("head")[0].appendChild(e); 
}

function addMarkersToMap()
{
    var initialLatLon = undefined;
        
    placesHash.each(function(pair) 
    {
        var myPlaceHash = pair.value;
        var myName = myPlaceHash.get('name');
        var myLat = parseFloat(myPlaceHash.get('latitude'));
        var myLon = parseFloat(myPlaceHash.get('longitude'));
                    
        if (myLat.toString() != 'NaN' && myLon.toString() != 'NaN')
        {
            var myMarkerHash = new Hash();
            var myLatLon = new YGeoPoint(myLat, myLon);
                            
            var myMarker= new YMarker(myLatLon);
            myMarker.addAutoExpand(myName);
            var markerMarkup = "Some More Text";
            
            // <a href=\"javascript:alert(\'foo\')\">Click</>
            YEvent.Capture(myMarker, EventsList.MouseClick, 
                function(){
                    //myMarker.openSmartWindow(markerMarkup);
                });
                
            myMarker.setSmartWindowColor('red');
            map.addOverlay(myMarker);
            
            myMarkerHash.set('marker', myMarker);
            myMarkerHash.set('latlon', myLatLon);
    
            locationMapMarkerHash.set(pair.key, myMarkerHash);
                        
            initialLatLon = myLatLon;
        }
    });	
    
    if (initialLatLon != undefined)
    {
        //map.setCenterByLatLonAndZoom(initialLatLon, 8, 2000);
        map.drawZoomAndCenter(initialLatLon, 5);
    }
}

function hideAllMapMarkers()
{
    var myMarker;
    
    for (var i = 0; i < locationMapMarkerHash.keys.length; i++)
    {
        myMarker = getMapMakerForLocationID(locationMapMarkerHash.keys[i]);
        if (myMarker != undefined)
        {
            myMarker.hide();
        }
    }
}

function filterMapMarkers(aLocataionIDArray)
{
    locationMapMarkerHash.each(function(pair) 
    {        
        var myMarker = getMapMakerForLocationID(pair.key);
        
        if (aLocataionIDArray.indexOf(pair.key) != -1)
        {
            myMarker.unhide();
        }
        else
        {
            myMarker.hide();
        }                    
    });
}

function getUniqueLocationIDArray()
{
    var myArray = new Array();
    var myPhotoHash;
    var myLocationID;
    
    for (var i = 0; i < currentlyDisplayedPhotos.length; i++)
    {
        myPhotoHash = currentlyDisplayedPhotos[i];
        myLocationID = myPhotoHash.get('locationID');
        
        if (myLocationID != undefined && (myArray.indexOf(myLocationID) == -1))
        {
            myArray[myArray.length] = myLocationID; 
        }
    }
    
    return myArray;
}

function showAllMapMarkers()
{
    locationMapMarkerHash.each(function(pair) 
    {        
        var myMarker = getMapMakerForLocationID(pair.key);
        myMarker.unhide();
    });
}

function showMarkerForLocationID(aLocationID)
{
    var myMarker = getMapMakerForLocationID(aLocationID);
    myMarker.unhide();
}

function highlightMapMarkerForLocationID(aLocationID)
{
    //hideAllMapMarkers();
    //showMarkerForLocationID(aLocationID);
    var myMarkerHash = locationMapMarkerHash.get(aLocationID);
    
    if (myMarkerHash == undefined)
        return;
        
    var myMarker = myMarkerHash.get('marker');
        
    //map.setCenterByLatLon(myMarkerHash.get('latlon'), 2000);
    //map.setCenterByLatLonAndZoom(myMarkerHash.get('latlon'), 5, 2000);
        
    map.drawZoomAndCenter(myMarkerHash.get('latlon'), 5);
    //map.panToLatLon(myMarkerHash.get('latlon'));

    
    if (currentMapMarker != undefined)
    {
        currentMapMarker.closeAutoExpand();
    }
    
    if (myMarker)
    {
        myMarker.openAutoExpand();
        currentMapMarker = myMarker;
    }
}

function getMapMakerForLocationID(aLocationID)
{
    var myMarkerHash = locationMapMarkerHash.get(aLocationID);
    
    if (myMarkerHash != undefined)
    {
        return myMarkerHash.get('marker');
    }
    
    return undefined;
}

function loadPicturesForPersonID(aPersonLinkID)
{		
    var myLink = $(aPersonLinkID);
    var myPersonID = aPersonLinkID.split('person-')[1];
    var photoIDToLoad;
                    
    if (currentPersonLink)
    {
        currentPersonLink.className = "";
        
        if (currentPersonLink == myLink)
        {
            currentPersonLink = myLink;
            
            if (!isShowingAll)
            {
                myLink.className = "";

                return showAllPictures('interactivePictureList');
            }
        }
    }
    
    myLink.className = "current";
    
    currentPersonLink = myLink;

    clearThumbnailDisplay('interactivePictureList');
    
    var myPhotoArray = getPhotosWithPersonID(myPersonID);
    var myPhotoHash;
        
    for (var i = 0; i < myPhotoArray.length; i++)
    {
        myPhotoHash = myPhotoArray[i];
        
        if (i == 0)
        {
             photoIDToLoad = myPhotoHash.get('objectID');
        }
        
        processThumbnailUsingPhotoHash(myPhotoHash, 'interactivePictureList', 'pic-', 'loadPictureWithID');
    }
    
    currentlyDisplayedPhotos = myPhotoArray;

    isShowingAll = false;
    loadPictureWithID(photoIDToLoad);
}

function showAllPictures(aDivName)
{
    clearThumbnailDisplay(aDivName);
    
    var myPhotoHash;
    
    for (var i = 0; i < photosArray.length; i++)
    {
        myPhotoHash = photosArray[i];
        
        processThumbnailUsingPhotoHash(myPhotoHash, aDivName, 'pic-', 'loadPictureWithID');
    }
    
    isShowingAll = true;
    currentPhotoIndex = 0;
}

function reloadCurrentPicture()
{		
    if (currentPhotoIndex)
    {
        if (currentlyDisplayedPhotos[currentPhotoIndex] >= 0)
        {
            var myPicID = currentlyDisplayedPhotos[currentPhotoIndex].get('objectID');
            loadPictureWithID(myPicID);
        }
    }
}

function clearSelectable()
{
    if (typeof(mySelectable) != 'undefined')
    {
        mySelectable.destroy();
        
        mySelectable = undefined;
    }
}

function loadPictureWithID(aPictureID)
{
    var myLink = document.getElementById('pic-'+aPictureID);
    var myPhotoHash = getPhotoWithObjectID(aPictureID);
    var myPictureInfoDiv = $('interactiveAttachments');
    var myPictureDiv = $('interactivePicture');
    var myMainDiv = $('main');
    var myPicID = "pic_" +aPictureID;
    var exportWidth = parseFloat(myPhotoHash.get('pixelsWide'));
    var exportHeight = parseFloat(myPhotoHash.get('pixelsHigh'));
    var pictureDivHeight = (myPictureDiv.offsetHeight *.99);
    var pictureDivWidth = (myPictureDiv.offsetWidth *.99);
    var widthScaleFactor = (pictureDivWidth / exportWidth);
    var heightScaleFactor = (pictureDivHeight / exportHeight);
    var scaleFactor = Math.min(widthScaleFactor, heightScaleFactor);
    var displayWidth = (scaleFactor * exportWidth);
    var displayHeight = (scaleFactor * exportHeight);
        
    //log('loadPictureWithID myPictureDiv is ' +myPictureDiv +' will set displayWidh to ' +displayWidth +' will set displayHeight to ' +displayHeight);
    
    clearSelectable();
    
    if (currentPictureLink)
    {
        currentPictureLink.className = "";
    }
    
    while (myPictureDiv.firstChild) 
    {
        myPictureDiv.removeChild(myPictureDiv.firstChild);
    };
    
    myLink.className = "current";
    currentPictureLink = myLink;
    //myPictureInfoDiv.innerHTML = htmlFragmentForPhotoHash(myPhotoHash);
    populatePhotoInfo(myPhotoHash);
    
    var myThumbnailImg = $('ph_'+aPictureID);
    
    //log('here in loadPictureWithID myThumbnailImg is ' +myThumbnailImg.src);
    
    // Create a new image, be sure to set the src
    // after setting the onLoad function otherwise there will
    // be firing errors in Safari
    myImage = new Image();
    myImage.id = myPicID;
    myPictureDiv.appendChild(myImage);

    myImage.onload = function() {
        //handleImageLoad(myPicID, myImage);
       handleImageLoad(myPicID);
    };
        
    // Once again IE blows, and we can't do the 
    // chunky pixels trick
    if (!isIE)
    {
        myImage.width = displayWidth;
        myImage.height = displayHeight;
        myImage.src = myPhotoHash.get('relativeThumbnailURL');;
    }
    else
    {
        //myImage.src = myThumbnailImg.src;
        myImage.src = myPhotoHash.get('relativeFileURL');
        myImage.width = displayWidth;
        myImage.height = displayHeight;
    }

    // handleImageLoad(myPicID);
    // handleImagePHLoad

    currentPhotoIndex = indexOfPhotoWithID(aPictureID);
}

function populatePhotoInfo(aPhotoHash)
{
    var myFragment;
    var myLocationID = aPhotoHash.get('locationID');
    var myLocationHash;
    var myNotes = aPhotoHash.get('notes');
    var myLocationName = "";
    var myAttachments = aPhotoHash.get('attachments');
    var myUUID = aPhotoHash.get('uuid');   
     
    Element.hide('attachmentsTitle');
    Element.hide('miniMapView');
    Element.hide('locationTitle');
    Element.hide('attachmentsTitle');
    Element.hide('attachmentsList');
    Element.hide('captionTitle');
    Element.hide('shareTitle');

    $('titleAndDate').innerHTML = "";
    $('caption').innerHTML = "";
    $('locationTitle').innerHTML = "";
    $('attachmentsList').innerHTML =  "";
    $('share').innerHTML =  "";

    // title and date
    $('titleAndDate').innerHTML = (aPhotoHash.get('title') +'<br>' +aPhotoHash.get('creationDateString'));
        
    if (myLocationID)
    {   
        var myLocationFrag = "";
        myLocationHash = placesHash.get(myLocationID);
        myLocationName = myLocationHash.get('name');

        //myLocationFrag += '<a href=\"javascript:showMiniMap(\'' +myLocationID +'\')\"></a>'
        //myLocationFrag += '<img src=\"images/placesIcon.png\" border=\"0\" valign=\"bottom\" id=\"placesLink\">' +myLocationName;
        myLocationFrag += myLocationName;
       
        Element.show('locationTitle');

        $('locationTitle').innerHTML = myLocationFrag;
        
        if (typeof YMap != 'undefined') 
        {
            showMiniMap(myLocationID);
        }
    }

    if (myAttachments)
    {	
       Element.show('attachmentsTitle');

        var myAttachmentsFrag = "<p>";
        var myURL;
        var myName;
        var myMediaType;
        
        for (var i = 0; i < myAttachments.length; i++)
        {
            myURL = myAttachments[i].get('url');
            myName = myAttachments[i].get('name');
            myMediaType = myAttachments[i].get('mediaType');
            
            // Escape single quotes!
            myURL = myURL.replace("'", "\\'");
                        
            log('myURL after cleansing is ' +myURL);

            myAttachmentsFrag += '<a href = \"javascript:popMedia(\''+myURL +'\',\'' +myMediaType +'\')\" style=\"text-decoration: none\">';
            myAttachmentsFrag += '<img src=\"images/paperclip.png\" id=\"attachmentLink\">' +myName +'</a><br />';
        }
        
        myAttachmentsFrag += "</p>";

        $('attachmentsList').innerHTML = myAttachmentsFrag;
    }

    if (myNotes.length)
    {
        $('caption').innerHTML = '<p>\n' +myNotes.split('\n').join('<br>');

        Element.show('captionTitle');
    }
    
    // Strips off possible queries that may exist in the original URL
    var myBaseURL = document.location.toString().split('?')[0].split('index.html')[0];    
    var myShareURL = (myBaseURL +'index.html?showPhoto=' +myUUID);
    var myFullThumbURL = (myBaseURL +aPhotoHash.get('relativeThumbnailURL'));
    
    // Escape, escape, escape!
    var myThumbEmbedString = '&lt;a href=&quot;' +myShareURL +'&quot; target=&quot;_blank&quot;&gt;&lt;img src=&quot;' +myFullThumbURL +'&quot;&gt;&lt;/a&gt;';
        
    // Build up Share links
    $('share').innerHTML = '<br><span class=\"linkLabel\">Link URL:</span></a><br><input name=\"shareLink\" class=\"linkTextField\" onClick=\"selectAndCopyText(this)\" type=\"text\" value=\"' +myShareURL +'\"><p>';
    $('share').innerHTML += ('<span class=\"linkLabel\">Embed Code (Websites & Blogs):</span></a><br><input name=\"shareImageLink\" onClick=\"selectAndCopyText(this)\" class=\"linkTextField\" type=\"text\" value=\"' +myThumbEmbedString +'\">');

    Element.show('shareTitle');
}

function handleImagePHLoad(aPicID)
{
   var myPhotoHash = getPhotoWithObjectID(aPicID.split('_')[1]);		
   var myPhotoElement = $(aPicID);
       
    if (myPhotoElement)
    {
/*        myPhotoElement.onload = function() {
            handleImageLoad(aPicID);
        };
        
        myPhotoElement.src = myPhotoHash.get('relativeFileURL');
        */
        
        myPhotoElement.onload = null;
        //handleImageLoad(aPicID);
    }
}

function handleImageLoad(anImageID, anImg)
{	   
    var myPhotoHash = getPhotoWithObjectID(anImageID.split('_')[1]);		
    var originalImageWidth = parseFloat(myPhotoHash.get('pixelsWide'));
    var originalImageHeight = parseFloat(myPhotoHash.get('pixelsHigh'));
    var myPhotoElement = document.getElementById(anImageID);
//    var myPhotoElement = anImg;
    var myPhotoURL = myPhotoHash.get('relativeFileURL');
    
    //log('here in handleImageLoad anImageID is is ' +anImageID);
    //log('myPhotoElement is ' +myPhotoElement);
    //log('myPhotoURL is ' +myPhotoURL);
        
    if (!isIE)
    {
        myPhotoElement.src = myPhotoURL;
    }
    
    myPhotoElement.onload = null;

    clearSelectable();
    
    if (typeof(myPhotoHash) != 'undefined')
    {
        var myMarkers = myPhotoHash.get('selectionMarkers');
                                
        if (typeof(myMarkers) != 'undefined')
        {             
                mySelectable = new Selectable(anImageID, { 
                onCreateSelected: markerCreated,
                onUpdateSelected: markerUpdated,
                onSelectSelected: didClickMarker, 
                onDeselectSelected: didClickMarker,
                stylesheet: 'css/selectable.css',
                readOnly: true
                });
            
            for (var i = 0; i < myMarkers.length; i++)
            {
                var myMarkerInfo = myMarkers[i];
                var myMarkerID = "marker_" +anImageID + '_' +i;
                var myPersonName = myMarkerInfo.get('personName');
                var myPersonID = myMarkerInfo.get('personObjectID')

                var selectedX1 = parseFloat(myMarkerInfo.get('x1'));
                var selectedY1 = parseFloat(myMarkerInfo.get('y1'));
                var selectedX2 = parseFloat(myMarkerInfo.get('x2'));
                var selectedY2 = parseFloat(myMarkerInfo.get('y2'));

                if (myPersonID != undefined)
                {
                    myMarkerID += '_person_' +myPersonID;
                }
                
                var myMarker = Selected.register(myMarkerID, anImageID, [selectedX1, selectedY1], [selectedX2, selectedY2], myPersonName);
            }
            
            mySelectable.load();
            mySelectable.activate();
            
            if (photoMarkerTimer)
                clearTimeout(photoMarkerTimer);

            photoMarkerTimer = setTimeout("hideAllPhotoMarkers()", 1500);
        }
        else
        {
            clearSelectable();
        }
    }
}

function hideAllPhotoMarkers()
{    
    if (typeof(mySelectable) != 'undefined')
    {
        mySelectable.deactivate();
    }
}

function configureMap()
{    
    if (map == undefined)
    {
        map = new YMap($('mapContainer'));
        
        map.addTypeControl();

        // Set map type to either of: YAHOO_MAP_SAT, YAHOO_MAP_HYB, YAHOO_MAP_REG
        map.setMapType(YAHOO_MAP_REG);
        
        map.addZoomLong();
        
        // Add the Pan Control
        map.addPanControl();
        
        //map.drawZoomAndCenter('San Francisco', 3);
                                
        addMarkersToMap();
    }
}
    
/*
function configureMap()
{							   	       
    var latlon = new LatLon(30.244047, -97.747175);
    map = new Map("mapContainer", "memoryminer", latlon, 14);
    map.addTool( new PanTool(), true );
    // Create a Navigator Widget object 
    navWidget = new NavigatorWidget();  
    // Add the Navigator Widget to the map and display it 
    map.addWidget(navWidget); 
    map.addWidget(new SatelliteControlWidget());
    map.enableKeyboardShortcuts(true);
}
*/

function markerCreated(id)
{
    //log('markerCreated called');
}

function markerUpdated(id)
{
    //log('markerUpdated called');
}

function didClickMarker(aMarker)
{
    var markerID = aMarker.toString();
    
    if (markerID.split('person_').length == 2)
    {
        var personID = markerID.split('person_')[1];
                    
        loadPicturesForPersonID('person-' +personID);
        
        //Element.scrollTo($('person-' +personID));
    }
}

function markerDeselected(aMarker)
{
    //log('markerDeselected called aMarker is ' +aMarker);
}

function populateMapPictureList()
{
    $('mapPictureList').innerHTML = "";
    
    var myPhotoHash;
    
    for (var i = 0; i < currentlyDisplayedPhotos.length; i++)
    {
        myPhotoHash = currentlyDisplayedPhotos[i];
        
        if (myPhotoHash.get('locationID'))
        {
            processThumbnailUsingPhotoHash(myPhotoHash, 'mapPictureList','map_pic-', 'highlightMapWithPictureID');
        }
                    
        //processThumbnail(myPhotoHash.get('relativeThumbnailURL'), myPhotoHash.get('objectID'), 'mapPictureList','map_pic-', 'highlightMapWithPictureID');
        
    }
}

function populateMapPeopleList()
{		    
    peopleHash.each(function(pair) 
    {
        var myPersonHash = pair.value;
                    
        processPersonIcon(myPersonHash.get('relativePersonIconURL'), pair.key, myPersonHash.get('personName'), 'mapPersonList', 'map_person-', 'filterUsingPersonLink');

    });
}

function filterUsingPersonLink(aPersonLinkID)
{
    var myLink = $(aPersonLinkID);
    var myIDPrefix = aPersonLinkID.split('-')[0] + '-';				
    var myPersonID = aPersonLinkID.split(myIDPrefix)[1];
    var myTargetDivName = 'interactivePictureList';
    var myJSFunctionName = 'loadPictureWithID';
    var firstPhotoID;
                   
    if (myIDPrefix == 'map_person-')
    {
        myTargetDivName = 'mapPictureList';	
        myJSFunctionName = 'highlightMapWithPictureID';	
        myIDPrefix = 'map_pic-';
    }
    
    if (currentPersonLink)
    {
        currentPersonLink.className = "";
        
        if (currentPersonLink == myLink)
        {				
            currentPersonLink = myLink;
            
            if (!isShowingAll)
            {
                myLink.className = "";

                 currentlyDisplayedPhotos = photosArray;
                clearThumbnailDisplay(myTargetDivName);
                isShowingAll = true;
                showAllMapMarkers();
                return populateMapPictureList();
            }
        }
    }
    
    myLink.className = "current";
    
    currentPersonLink = myLink;

    clearThumbnailDisplay(myTargetDivName);
    
    var myPhotoArray = getPhotosWithPersonID(myPersonID);
    var myPhotoHash;
        
    for (var i = 0; i < myPhotoArray.length; i++)
    {
        myPhotoHash = myPhotoArray[i];
        
        if (i == 0)
            firstPhotoID = myPhotoHash.get('objectID');
        
        processThumbnailUsingPhotoHash(myPhotoHash, myTargetDivName, myIDPrefix, myJSFunctionName);
    }
    
    currentlyDisplayedPhotos = myPhotoArray;

    filterMapMarkers(getUniqueLocationIDArray());
    
    isShowingAll = false;
    
    if (firstPhotoID)
        highlightMapWithPictureID(firstPhotoID);

}

function highlightMapWithPictureID(aPictureID)
{
    var myPhotoHash = getPhotoWithObjectID(aPictureID);
    var myLocationID = myPhotoHash.get('locationID');
    var myLink = $('map_pic-'+aPictureID);
                 
    if (currentPictureLink)
    {
        currentPictureLink.className = "";
    }
    
    myLink.className = "current";
    
    currentPictureLink = myLink;
    
    if (myLocationID)
    {
        highlightMapMarkerForLocationID(myLocationID);
    }
    
    currentPhotoIndex = indexOfPhotoWithID(aPictureID);
}

function htmlFragmentForPhotoHash(aPhotoHash)
{	
    var myFragment = "<p>\n<strong>";
    var myLocationID = aPhotoHash.get('locationID');
    var myLocationHash;
    var myNotes = aPhotoHash.get('notes');
    var myLocationName = "";
    var myAttachments = aPhotoHash.get('attachments');
    
    if (myLocationID)
    {
        myLocationHash = placesHash.get(myLocationID);
        myLocationName = myLocationHash.get('name');
    }
    
    myFragment += aPhotoHash.get('title') +'</strong>\n<br />\n';
    myFragment += aPhotoHash.get('creationDateString') +'<br />\n';
    
    if (myLocationID)
    {
        myFragment += '<a href=\"javascript:showMiniMap(\'' +myLocationID +'\')\" style=\"text-decoration: none\">'
        myFragment += '<img src=\"images/placesIcon.png\" border=\"0\" valign=\"bottom\" id=\"placesLink\">' +myLocationName +'</a><p />\n';
    }
    else
        myFragment += myLocationName +'<p />\n';

    if (myAttachments)
    {			
        var myURL;
        var myName;
        var myMediaType;

        for (var i = 0; i < myAttachments.length; i++)
        {
            myURL = myAttachments[i].get('url');
            myName = myAttachments[i].get('name');
            myMediaType = myAttachments[i].get('mediaType');

            myFragment += '<a href = \"javascript:popMedia(\''+myURL +'\',\'' +myMediaType +'\')\" style=\"text-decoration: none\">';
            myFragment += '<img src=\"images/paperclip.png\" id=\"attachmentLink\">' +myName +'</a><br />';
        }
    }

    myFragment += '<p>\n' +myNotes.split('\n').join('<br>') +'</p>';
        
    return myFragment;
}

function hideMiniMap()
{
    Element.hide('interactiveMapView');
    miniMapIsVsible = false;
}

function toggleMiniMap(aLocationID)
{    
    showMiniMap(aLocationID);
}

function configureMiniMap()
{
    if (miniMap == undefined)
    {
        miniMap = new YMap($('miniMapView'));
        
        miniMap.addTypeControl();

        // Set map type to either of: YAHOO_MAP_SAT, YAHOO_MAP_HYB, YAHOO_MAP_REG
        miniMap.setMapType(YAHOO_MAP_REG);
        
        miniMap.addZoomLong();
        
        // Add the Pan Control
        miniMap.addPanControl();
        
        // San Francisco
        var initialLatLon = new YGeoPoint(37.7733, -122.4178);
        
        miniMap.drawZoomAndCenter(initialLatLon, 5)

        miniMapMarker = new YMarker(initialLatLon);
        miniMapMarker.setSmartWindowColor('red');

        miniMap.addOverlay(miniMapMarker);
    }
}

function showMiniMap(aLocationID)
{    
    Element.show('miniMapView');
    
    configureMiniMap();
    
    var myPlaceHash = placesHash.get(aLocationID);
    var myLat = parseFloat(myPlaceHash.get('latitude'));
    var myLon = parseFloat(myPlaceHash.get('longitude'));
                    
    if (myLat.toString() != 'NaN' && myLon.toString() != 'NaN')
    {
        var myLatLon = new YGeoPoint(myLat, myLon);
        miniMapMarker.setYGeoPoint(myLatLon);
        
        miniMap.drawZoomAndCenter(myLatLon, 5);
    }   
}


function clearThumbnailDisplay(aDivName)
{
    $(aDivName).innerHTML = "";
}

function didFinishParsing()
{
   var idToLoad = requestedPhotoID;
   
   // highlight the image and scroll its parent view so that it's 
   // visible
   if (idToLoad != undefined)
   {
       var thumbLinkDiv = $('pic-'+idToLoad);
       var scrollList = $('interactivePictureList');
                     
        scrollList.scrollLeft = thumbLinkDiv.offsetLeft;
   }
   else
   {
        idToLoad = photosArray[0].get('objectID');
   }
      
    loadPictureWithID(idToLoad);
    populateMapPeopleList();
    $('all').style.visibility = 'visible';
    Element.hide('loader');
    
    photoInfoAccordion = new accordion('infoAccordian', {
        classNames : {
            toggle : 'accordion_toggle',
            toggleActive : 'accordion_toggle_active',
            content : 'accordion_content'
        }
    });
			
    var verticalAccordions = $$('.accordion_toggle');

    verticalAccordions.each(function(accordion) {
        $(accordion.next(0)).setStyle({
        height: '0px'
        });
    });
    
    photoInfoAccordion.activate($$('#infoAccordian .accordion_toggle')[0]);

}

function beginSlideShow()
{
    nav.viewer();
    
    //$('main').style.margin = "0px";
    
    Element.show('mySlideshow');
    
    //var topContainerDiv = document.getElementById('topContainer');
    var slideShowDiv = $('mySlideshow');
    
    slideShowIsPaused = false;
    
    clearSelectable();
            
    $('pausePlay').src = "images/pause_button.gif";
    
    slideShowDiv.style.width = "800px";
    slideShowDiv.style.height = "540px";

    var mySlideData = getSlideShowData();
    
    if (currentPhotoIndex < 0)
    {
        currentPhotoIndex = 0;
    }
    
    activeSlideShow = new timedSlideShow($('mySlideshow'), mySlideData, currentPhotoIndex);

}
    
function getSlideShowData()
{
    var mySlideData = new Array();
    var myPhotoHash;
    
    for (var i = 0; i < currentlyDisplayedPhotos.length; i++)
    {
        myPhotoHash = currentlyDisplayedPhotos[i];
        
        mySlideData[mySlideData.length] = new Array(
            myPhotoHash.get('relativeFileURL'),
            '#',
            myPhotoHash.get('title'),
            myPhotoHash.get('notes')
        );
    }
            
    return mySlideData;
}

function togglePausePlay()
{    
    if (slideShowIsPaused)
    {
        activeSlideShow.doSlideShow();
    }
    else
    {
        activeSlideShow.killSlideShowTimers();
    }
            
    slideShowIsPaused = !slideShowIsPaused;
    
    togglePausePlayLabel()
}

function togglePausePlayLabel()
{
    var myLabel = "Play";
    var myImgSrc = "images/pause_rollover.gif";
    
    if (slideShowIsPaused)
        myImgSrc = "images/play_rollover.gif";
        //myLabel = "Pause";
    
    //$('pausePlay').innerHTML = myLabel;
    $('pausePlay').src = myImgSrc;

}

function showNextSlide()
{
    activeSlideShow.killSlideShowTimers();
    activeSlideShow.nextSlideShow();
    
    if (slideShowIsPaused)
    {
        togglePausePlayLabel();
        slideShowIsPaused = false;
    }
}

function showPriorSlide()
{
    activeSlideShow.killSlideShowTimers();
    activeSlideShow.prevSlideShow();
    
    if (slideShowIsPaused)
    {
        togglePausePlayLabel();
        slideShowIsPaused = false;
    }
}

function cleanupSlideShow()
{
    $('mySlideshow').innerHTML = "";
    activeSlideShow = undefined;
}

function stopSlideShow()
{
    var slideShowDiv = document.getElementById('mySlideshow');
    currentPhotoIndex = activeSlideShow.currentIter;
    
    $('stop').src = "images/stop_button.gif";

    cleanupSlideShow();
    reloadCurrentPicture();
    
    nav.interactive();
}

function popMedia(url, type)
{
    var w, h

    if (type == 'audio')
    {
        w = 450
        h = 100
    } 
    else if (type == 'video')
    {
        w = 480
        h = 495
    } 
    else 
    {
        w = 800
        h = 600
    }

    if (bReuseMediaWindow && mediaWindow != null){
        mediaWindow.close()
        mediaWindow = null
    }

    var winName = bReuseMediaWindow ? "MMMedia" : ""

    mediaWindow = window.open(url, winName, "scrollbars=1,status=0,width=" + w + ",height=" + h + ",left="+(screenW-w)+",top=0");
    mediaWindow.focus();
}

function MM_preloadImages(){ //v3.0
  var d=document; if(d.images){ if(!d.MM_p) d.MM_p=new Array();
    var i,j=d.MM_p.length,a=MM_preloadImages.arguments; for(i=0; i<a.length; i++)
    if (a[i].indexOf("#")!=0){ d.MM_p[j]=new Image; d.MM_p[j++].src=a[i];}}
}

function MM_swapImgRestore() { //v3.0
  var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;
}

function MM_findObj(n, d) { //v4.01
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document);
  if(!x && d.getElementById) x=d.getElementById(n); return x;
}

function MM_swapImage() { //v3.0
  var i,j=0,x,a=MM_swapImage.arguments; document.MM_sr=new Array; for(i=0;i<(a.length-2);i+=3)
   if ((x=MM_findObj(a[i]))!=null){document.MM_sr[j++]=x; if(!x.oSrc) x.oSrc=x.src; x.src=a[i+2];}
}

function mouseOverPausePlayIMG()
{
    var myIMGSrc = "images/pause_rollover.gif";
    
    if (slideShowIsPaused)
        myIMGSrc = "images/play_rollover.gif";
        
    $('pausePlay').src = myIMGSrc;
}

function restorePausePlayIMG()
{
    var myIMGSrc = "images/pause_button.gif";
    
    if (slideShowIsPaused)
        myIMGSrc = "images/play_button.gif";
        
    $('pausePlay').src = myIMGSrc;
}

function selectAndCopyText(aTextField)
{
    aTextField.select();
    copyToClipboard(aTextField.value);
}

function copyToClipboard(s)
{
	if( window.clipboardData && clipboardData.setData )
	{
		clipboardData.setData("Text", s);
	}
}

