//
//  MMSBitmapUnarchiveOperation.h
//  MMSBase
//
//  Created by John Fox on 6/24/09.
//  Copyright 2009 GroupSmarts, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MMSPhoto.h"


@interface MMSBitmapUnarchiveOperation : NSOperation
{
	NSData *archiveData;
	NSString *objectID;
	
	BOOL isExecuting;
    BOOL isFinished;
}

@property (readonly, copy) NSData *archiveData;
@property (retain) NSString *objectID;

@property (readonly) BOOL isExecuting;
@property (readonly) BOOL isFinished;

+ (id)newWithWithPhotoID:(NSString *)anObjectID;

- (id)initWithArchiveData:(NSData *)anArchive;

- (void)finish;

@end
